/* $Id: api.c,v 1.1 2000/12/10 11:31:36 marcus Exp $
******************************************************************************

   GGIGL extension API functions

   Copyright (C) 2000 Marcus Sundberg	[marcus@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#include <ggi/internal/ggigl.h>
#include <ggi/ggigl.h>

void
ggiglSetAttribs(ggi_visual_t vis, int *attribs)
{
	ggiglpriv *priv;

	if (attribs == NULL) return;

	priv = GGIGLEXT_PRIV(vis);

	while (*attribs != GGIGL_NONE) {
		switch (*attribs++) {
		case GGIGL_BUFFER_SIZE:
			priv->attribs.buffer_size = *attribs++;
			break;
		case GGIGL_LEVEL:
			priv->attribs.level = *attribs++;
			break;
		case GGIGL_RGBA:
			priv->attribs.rgba = 1;
			break;
		case GGIGL_DOUBLEBUFFER:
			priv->attribs.doublebuffer = 1;
			break;
		case GGIGL_STEREO:
			priv->attribs.stereo = 1;
			break;
		case GGIGL_AUX_BUFFERS:
			priv->attribs.aux_buffers = *attribs++;
			break;
		case GGIGL_RED_SIZE:
			priv->attribs.red_size = *attribs++;
			break;
		case GGIGL_GREEN_SIZE:
			priv->attribs.green_size = *attribs++;
			break;
		case GGIGL_BLUE_SIZE:
			priv->attribs.blue_size = *attribs++;
			break;
		case GGIGL_ALPHA_SIZE:
			priv->attribs.alpha_size = *attribs++;
			break;
		case GGIGL_DEPTH_SIZE:
			priv->attribs.depth_size = *attribs++;
			break;
		case GGIGL_STENCIL_SIZE:
			priv->attribs.stencil_size = *attribs++;
			break;
		case GGIGL_ACCUM_RED_SIZE:
			priv->attribs.accum_red_size = *attribs++;
			break;
		case GGIGL_ACCUM_GREEN_SIZE:
			priv->attribs.accum_green_size = *attribs++;
			break;
		case GGIGL_ACCUM_BLUE_SIZE:
			priv->attribs.accum_blue_size = *attribs++;
			break;
		case GGIGL_ACCUM_ALPHA_SIZE:
			priv->attribs.accum_alpha_size = *attribs++;
			break;
		default:
			break;
		}
	}
}


void
ggiglSwapBuffers(ggi_visual_t vis)
{
	printf("ggiglSwapBuffers\n");
	GGIGLEXT_PRIV(vis)->swapbuffers(vis);
}
